#version 300 es
precision highp float;
precision highp int;

uniform mediump samplerCube _BaseCubemap;
uniform mediump float _Rotation;
uniform mediump float _Exposure;
uniform mediump vec4 _BaseColor;
uniform mediump vec4 u_WorldSpaceCameraPos;

layout(location = 0) out vec4 o_fragColor;
in vec3 v_WorldSpacePos;

mediump vec3 SampleCubemap(mediump samplerCube cubemap, inout mediump vec3 dir, mediump float lod)
{
    dir = normalize(dir);
    return texture(cubemap, dir, lod).xyz;
}

mediump vec3 SampleCubemap(mediump samplerCube cubemap, inout mediump vec3 dir, mediump float rotation, mediump float lod)
{
    mediump float rad = rotation * 0.01745329238474369049072265625;
    dir = vec3((cos(rad) * dir.x) + (sin(rad) * (-dir.z)), dir.y, ((-sin(rad)) * dir.x) + (cos(rad) * (-dir.z)));
    mediump vec3 param = dir;
    mediump float param_1 = lod;
    mediump vec3 _76 = SampleCubemap(cubemap, param, param_1);
    dir = param;
    return _76;
}

void main()
{
    o_fragColor = vec4(0.0, 0.0, 0.0, 1.0);
    mediump vec3 viewDir = normalize(v_WorldSpacePos);
    mediump vec3 param = viewDir;
    mediump float param_1 = _Rotation;
    mediump float param_2 = 0.0;
    mediump vec3 _99 = SampleCubemap(_BaseCubemap, param, param_1, param_2);
    viewDir = param;
    mediump vec3 skyboxColor = _99;
    mediump vec3 outputColor = (skyboxColor * _Exposure) * _BaseColor.xyz;
    o_fragColor = vec4(outputColor, _BaseColor.w);
}

