#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct buffer_t
{
    float _Rotation;
    float _Exposure;
    float4 _BaseColor;
};

struct main0_out
{
    float4 o_fragColor [[color(0)]];
};

struct main0_in
{
    float3 v_WorldSpacePos;
};

static inline __attribute__((always_inline))
float3 SampleCubemap(thread const texturecube<float> cubemap, thread const sampler cubemapSmplr, thread float3& dir, thread const float& lod)
{
    dir = normalize(dir);
    return cubemap.sample(cubemapSmplr, dir, bias(lod)).xyz;
}

static inline __attribute__((always_inline))
float3 SampleCubemap(thread const texturecube<float> cubemap, thread const sampler cubemapSmplr, thread float3& dir, thread const float& rotation, thread const float& lod)
{
    float rad = rotation * 0.01745329238474369049072265625;
    dir = float3((cos(rad) * dir.x) + (sin(rad) * (-dir.z)), dir.y, ((-sin(rad)) * dir.x) + (cos(rad) * (-dir.z)));
    float3 param = dir;
    float param_1 = lod;
    float3 _76 = SampleCubemap(cubemap, cubemapSmplr, param, param_1);
    dir = param;
    return _76;
}

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texturecube<float> _BaseCubemap [[texture(0)]], sampler _BaseCubemapSmplr [[sampler(0)]])
{
    main0_out out = {};
    out.o_fragColor = float4(0.0, 0.0, 0.0, 1.0);
    float3 viewDir = normalize(in.v_WorldSpacePos);
    float3 param = viewDir;
    float param_1 = buffer._Rotation;
    float param_2 = 0.0;
    float3 _99 = SampleCubemap(_BaseCubemap, _BaseCubemapSmplr, param, param_1, param_2);
    viewDir = param;
    float3 skyboxColor = _99;
    float3 outputColor = (skyboxColor * buffer._Exposure) * buffer._BaseColor.xyz;
    out.o_fragColor = float4(outputColor, buffer._BaseColor.w);
    return out;
}

